package com.example.switchyard.switchyard_database_binding;

import java.util.List;

import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceUnit;

@Stateless
@TransactionAttribute(TransactionAttributeType.NEVER)
public class TestEntityDAO {

    @PersistenceUnit(unitName="switchyard-database-binding")
    private EntityManagerFactory factory;

    public TestEntity get(Long id) {
        EntityManager em = getEntityManager();
        try {
            if(id == null)
                return null;
            return em.find(TestEntity.class, id);
        } finally {
            em.close();
        }
    }

    public List<TestEntity> getAll() {
        EntityManager em = getEntityManager();
        try {
            return getEntityManager().createQuery("select e from TestEntity e").getResultList();
        } finally {
            em.close();
        }
    }

    public boolean delete(Long id) {
        EntityManager em = getEntityManager();
        em.getTransaction().begin();
        try {
            TestEntity te = em.find(TestEntity.class, id);
            if(te != null) {
                em.remove(te);
                return true;
            } else {
                return false;
            }
        } finally {
            em.getTransaction().commit();
            em.close();
        }
    }

    public TestEntity insert(TestEntity testEntity) {
        EntityManager em = getEntityManager();
        em.getTransaction().begin();
        try {
            if(
                    em.contains(testEntity)
                    || (testEntity.getId() != null && em.find(TestEntity.class, testEntity.getId()) != null)
                    ) {
                testEntity = em.merge(testEntity);
            } else {
                em.persist(testEntity);
            }
            return testEntity;
        } finally {
            em.getTransaction().commit();
            em.close();
        }
    } 

    private EntityManager getEntityManager() {
        return factory.createEntityManager();
    }
}
